      SUBROUTINE LLSQ
      IMPLICIT REAL*8 (A-H,O-Z)
      INCLUDE 'MAX.INC'
      INCLUDE 'LLSQDAT.INC'
      DIMENSION AUX(2*MAXPAR),IPIV(2*MAXPAR)
      PIV=0
      DO 4 K=1,NPAR
      IPIV(K)=K
      H=0
      DO 2 I=1,NEQ
    2 H=H+DER(K,I)**2
      AUX(K)=H
      IF(H.GT.PIV)THEN
        PIV=H
        KPIV=K
      ENDIF
    4  CONTINUE

      IF(PIV.LE.0) THEN
        WRITE (*,600)
  600   FORMAT (16H  MATRIX IS ZERO)
        RETURN
      ENDIF

C
      SIG=SQRT(PIV)
      DO 210 K=1,NPAR
      IF(KPIV.GT.K)THEN
        H=AUX(K)
        AUX(K)=AUX(KPIV)
        AUX(KPIV)=H
        DO 7 I=K,NEQ
        H=DER(K,I)
        DER(K,I)=DER(KPIV,I)
    7   DER(KPIV,I)=H
        ENDIF
      IF(K.GT.1)THEN
        SIG=0.D0
        DO 10 I=K,NEQ
   10   SIG=SIG+DER(K,I)**2
        SIG=DSQRT(SIG)
        ENDIF
      H=DER(K,K)
      IF(H.LT.0)THEN
        SIG=-SIG
        ENDIF
      IPIV(KPIV)=IPIV(K)
      IPIV(K)=KPIV
      BETA=H+SIG
      DER(K,K)=BETA
      BETA=1.D0/(SIG*BETA)
      J=NPAR+K
      AUX(J)=-SIG
      IF(K.LT.NPAR)THEN
        PIV=0.D0
        DO 18 J=K+1,NPAR
        H=0.D0
        DO 15 I=K,NEQ

   15   H=H+DER(K,I)*DER(J,I)
        H=BETA*H
        DO 16 I=K,NEQ
   16   DER(J,I)=DER(J,I)-DER(K,I)*H
        H=AUX(J)-DER(J,K)**2
        AUX(J)=H
        IF(H.GT.PIV)THEN
          PIV=H
          KPIV=J
        ENDIF
   18   CONTINUE
      ENDIF
   19 CONTINUE

      H=0
      DO 20 I=K,NEQ
   20 H=H+DER(K,I)*BARB(I)
      H=BETA*H
      DO 21 I=K,NEQ
   21 BARB(I)=BARB(I)-DER(K,I)*H
  210 CONTINUE
C
      UPU(NPAR)=BARB(NPAR)/AUX(2*NPAR)
      IF(NPAR.EQ.1)RETURN
      DO 25 J=2,NPAR
      H=BARB(NPAR+1-J)
      DO 24 I=NPAR+2-J,NPAR
   24 H=H-DER(I,NPAR+1-J)*UPU(I)
      H=H/AUX(2*NPAR+1-J)
      UPU(NPAR+1-J)=UPU(IPIV(NPAR+1-J))
      UPU(IPIV(NPAR+1-J))=H
   25 CONTINUE

      RETURN
      END
